/************************************************************/
/*	vWFNg:	sampleC									*/
/*	t@CF	OAKS16.h								*/
/*	eF			M16C/62A SFR`t@C				*/
/*	tF			2001.10.5								*/
/*	RpC:		NC30WA (Ver.4.00)						*/
/*	note:			OAKS16Ή								*/
/*	쐬ҁF		OAKS16KIT support						*/
/************************************************************/

#pragma ADDRESS p0_addr			3e0H	/* Port P0 register					*/
#pragma ADDRESS pd0_addr		3e2H	/* Port P0 direction register 		*/
#pragma ADDRESS tabsr_addr		380H	/* Count start flag					*/
#pragma ADDRESS udf_addr		384H	/* Up-down flag						*/
#pragma ADDRESS ta0_addr		386H	/* Timer A0 register				*/
#pragma ADDRESS ta0mr_addr		396H	/* Timer A0 mode register			*/
#pragma ADDRESS ta0ic_addr		55H		/* Timer A0 interrupt control register */

/*-----------------------------------------------------------------------
    Up/down flag ; Use "MOV" instruction when writing to this register.
-------------------------------------------------------------------------*/
unsigned char   udf_addr;               /* UP/down flag */
#define     udf     udf_addr
/********************************************************
*   declare  SFR short                                  *
********************************************************/
/*--------------------------------------------------------
    Timer registers : Read and write data in 16-bit units.
--------------------------------------------------------*/

unsigned short   ta0_addr;              /* Timer A0 register */
#define     ta0     ta0_addr

/*********************************************************/
/*   declare SFR bit                                     */
/*********************************************************/
struct bit_def {
        char    b0:1;
        char    b1:1;
        char    b2:1;
        char    b3:1;
        char    b4:1;
        char    b5:1;
        char    b6:1;
        char    b7:1;
};
union byte_def{
    struct bit_def bit;
    char    byte;
};

/*-------------------------------------------------------------------------
    Count start flag
--------------------------------------------------------------------------*/
union byte_def tabsr_addr;
#define     tabsr       tabsr_addr.byte

#define     ta0s        tabsr_addr.bit.b0   /* Timer A0 count start flag */
#define     ta1s        tabsr_addr.bit.b1   /* Timer A1 count start flag */
#define     ta2s        tabsr_addr.bit.b2   /* Timer A2 count start flag */
#define     ta3s        tabsr_addr.bit.b3   /* Timer A3 count start flag */
#define     ta4s        tabsr_addr.bit.b4   /* Timer A4 count start flag */
#define     tb0s        tabsr_addr.bit.b5   /* Timer B0 count start flag */
#define     tb1s        tabsr_addr.bit.b6   /* Timer B1 count start flag */
#define     tb2s        tabsr_addr.bit.b7   /* Timer B2 count start flag */

/*------------------------------------------------------
    Port P0 register
------------------------------------------------------*/
union byte_def p0_addr;
#define     p0      p0_addr.byte

#define     p0_0        p0_addr.bit.b0      /* Port P00 register */
#define     p0_1        p0_addr.bit.b1      /* Port P01 register */
#define     p0_2        p0_addr.bit.b2      /* Port P02 register */
#define     p0_3        p0_addr.bit.b3      /* Port P03 register */
#define     p0_4        p0_addr.bit.b4      /* Port P04 register */
#define     p0_5        p0_addr.bit.b5      /* Port P05 register */
#define     p0_6        p0_addr.bit.b6      /* Port P06 register */
#define     p0_7        p0_addr.bit.b7      /* Port P07 register */

/*------------------------------------------------------
    Port P0 direction register
------------------------------------------------------*/
union byte_def pd0_addr;
#define     pd0     pd0_addr.byte

#define     pd0_0       pd0_addr.bit.b0     /* Port P00 direction register */
#define     pd0_1       pd0_addr.bit.b1     /* Port P01 direction register */
#define     pd0_2       pd0_addr.bit.b2     /* Port P02 direction register */
#define     pd0_3       pd0_addr.bit.b3     /* Port P03 direction register */
#define     pd0_4       pd0_addr.bit.b4     /* Port P04 direction register */
#define     pd0_5       pd0_addr.bit.b5     /* Port P05 direction register */
#define     pd0_6       pd0_addr.bit.b6     /* Port P06 direction register */
#define     pd0_7       pd0_addr.bit.b7     /* Port P07 direction register */

/********************************************************
*   declare SFR union                                   *
********************************************************/
/*------------------------------------------------------
    interrupt control registers
------------------------------------------------------*/
union{
    struct{
        char    ilvl0:1;            /* Interrupt priority level select bit */
        char    ilvl1:1;            /* Interrupt priority level select bit */
        char    ilvl2:1;            /* Interrupt priority level select bit */
        char    ir:1;               /* Interrupt request bit */
        char    pol:1;              /* Polarity select bit */
        char    lvs:1;
        char    b6:1;
        char    b7:1;
    }bit;
    char    byte;
} ta0ic_addr;

/*------------------------------------------------------
     ta0ic
------------------------------------------------------*/
#define     ta0ic       ta0ic_addr.byte

#define     ilvl0_ta0ic ta0ic_addr.bit.ilvl0    /* Interrupt priority level select bit */
#define     ilvl1_ta0ic ta0ic_addr.bit.ilvl1    /* Interrupt priority level select bit */
#define     ilvl2_ta0ic ta0ic_addr.bit.ilvl2    /* Interrupt priority level select bit */
#define     ir_ta0ic    ta0ic_addr.bit.ir       /* Interrupt request bit */
/*------------------------------------------------------
    Timer mode registers
------------------------------------------------------*/
union{
    struct{
        char    tmod0:1;            /* Operation mode select bit */
        char    tmod1:1;            /* Operation mode select bit */
        char    mr0:1;
        char    mr1:1;
        char    mr2:1;
        char    mr3:1;
        char    tck0:1;             /* Count source select bit */
        char    tck1:1;             /* Count source select bit */
    }bit;
    char    byte;
}ta0mr_addr;

/*------------------------------------------------------
     ta0mr
------------------------------------------------------*/
#define     ta0mr       ta0mr_addr.byte

#define     tmod0_ta0mr ta0mr_addr.bit.tmod0        /* Operation mode select bit */
#define     tmod1_ta0mr ta0mr_addr.bit.tmod1        /* Operation mode select bit */
#define     mr0_ta0mr   ta0mr_addr.bit.mr0
#define     mr1_ta0mr   ta0mr_addr.bit.mr1
#define     mr2_ta0mr   ta0mr_addr.bit.mr2
#define     mr3_ta0mr   ta0mr_addr.bit.mr3
#define     tck0_ta0mr  ta0mr_addr.bit.tck0         /* Count source select bit */
#define     tck1_ta0mr  ta0mr_addr.bit.tck1         /* Count source select bit */
